#############################################################
#
# dropbear
#
#############################################################

DROPBEAR_SOURCE_URL=http://matt.ucc.asn.au/dropbear/releases/
DROPBEAR_SOURCE=dropbear-0.43.tar.bz2
DROPBEAR_DIR=$(BUILD_DIR)/dropbear-0.43

DROPBEAR_PKG_DIR=$(PACKAGES_DIR)/dropbear

$(DL_DIR)/$(DROPBEAR_SOURCE):
	 $(WGET) -P $(DL_DIR) $(DROPBEAR_SOURCE_URL)$(DROPBEAR_SOURCE)

dropbear-source: $(DL_DIR)/$(DROPBEAR_SOURCE)

$(DROPBEAR_DIR)/.unpacked: $(DL_DIR)/$(DROPBEAR_SOURCE)
	bzcat $(DL_DIR)/$(DROPBEAR_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	touch $(DROPBEAR_DIR)/.unpacked

$(DROPBEAR_DIR)/.configured: $(DROPBEAR_DIR)/.unpacked
	(cd $(DROPBEAR_DIR); rm -rf config.cache; \
		./configure --prefix=$(DROPBEAR_PKG_DIR)/usr \
		--disable-lastlog \
		--disable-utmp \
		--disable-utmpx \
		--disable-wtmp \
		--disable-wtmpx \
		--disable-pututline \
		--disable-pututxline \
		--disable-zlib \
		--disable-shadow \
	);
	$(SED) "s/^#define ENABLE_X11FWD/#define DISABLE_X11FWD/;" $(DROPBEAR_DIR)/options.h
	# $(SED) "s/^#define ENABLE_LOCALTCPFWD/#define DISABLE_LOCALTCPFWD/;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^#define ENABLE_REMOTETCPFWD/#define DISABLE_REMOTETCPFWD/;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^#define ENABLE_AGENTFWD/#define DISABLE_AGENTFWD/;" $(DROPBEAR_DIR)/options.h
	$(SED) 's/^#define DROPBEAR_AES128_CBC/\/* #define DROPBEAR_AES128_CBC *\//;' $(DROPBEAR_DIR)/options.h;
	$(SED) "s/^#define DROPBEAR_TWOFISH128_CBC/\/* #define DROPBEAR_TWOFISH128_CBC *\//;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^#define DROPBEAR_MD5_HMAC/\/* #define DROPBEAR_MD5_HMAC *\//;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^#define DO_MOTD/\/* #define DO_MOTD *\//;" $(DROPBEAR_DIR)/options.h
	$(SED) 's/^#define SFTPSERVER_PATH(.*)$$/\/* #define SFTPSERVER_PATH$$1*\//;' $(DROPBEAR_DIR)/options.h
	$(SED) "s/^\/\* #define NO_FAST_EXPTMOD \*\//#define NO_FAST_EXPTMOD /;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^\/\* #define DROPBEAR_MULTI \*\//#define DROPBEAR_MULTI /;" $(DROPBEAR_DIR)/options.h
	$(SED) "s/^#define DBMULTI_CONVERT/\/* #define DBMULTI_CONVERT *\//;" $(DROPBEAR_DIR)/options.h
	touch $(DROPBEAR_DIR)/.configured

$(DROPBEAR_DIR)/dropbearmulti: $(DROPBEAR_DIR)/.configured
	$(MAKE) -C $(DROPBEAR_DIR) dropbearmulti
	$(MAKE) -C $(DROPBEAR_DIR) STRIP=$(SSTRIP) stripmulti
	# $(MAKE) -C $(DROPBEAR_DIR)
	# $(MAKE) -C $(DROPBEAR_DIR) STRIP=$(SSTRIP) strip

$(DROPBEAR_PKG_DIR)/usr/sbin/dropbear: $(DROPBEAR_DIR)/dropbearmulti
	-rm -rf  $(DROPBEAR_PKG_DIR)
	mkdir $(DROPBEAR_PKG_DIR)
	mkdir $(DROPBEAR_PKG_DIR)/etc
	mkdir $(DROPBEAR_PKG_DIR)/etc/dropbear
	mkdir $(DROPBEAR_PKG_DIR)/usr
	mkdir $(DROPBEAR_PKG_DIR)/usr/bin
	mkdir $(DROPBEAR_PKG_DIR)/usr/sbin
	cp -a $(DROPBEAR_DIR)/dropbearmulti $(DROPBEAR_PKG_DIR)/usr/sbin
	( cd $(DROPBEAR_PKG_DIR)/usr/sbin; \
	ln -s dropbearmulti dropbear )
	( cd $(DROPBEAR_PKG_DIR)/usr/bin; \
	ln -s ../sbin/dropbearmulti dropbearkey )
	cp $(PACKAGES_INI_DIR)/post-dropbear.ini $(DROPBEAR_PKG_DIR)/etc/post-dropbear.ini

dropbear: $(DROPBEAR_PKG_DIR)/usr/sbin/dropbear

dropbear-clean:
	-$(MAKE) -C $(DROPBEAR_DIR) clean
	-rm -rf $(DROPBEAR_PKG_DIR)/*

dropbear-dirclean:
	-rm -rf $(DROPBEAR_DIR)
	-rm -rf  $(DROPBEAR_PKG_DIR)
