
floppydir:
	-mv $(BASE_DIR)/floppy.old $(BASE_DIR)/floppy.old2
	-mv $(BASE_DIR)/floppy $(BASE_DIR)/floppy.old
	-rm -rf $(BASE_DIR)/floppy.old2
	mkdir $(BASE_DIR)/floppy
	
	mkdir $(BASE_DIR)/floppy/packages
	mkdir $(BASE_DIR)/floppy/modules
	
	# I haven't had anything there for ages.
	# cp -a $(LICENSES_DIR) $(BASE_DIR)/floppy/.
	
	cp $(INITRD_DIR)/initrd.gz $(BASE_DIR)/floppy/initrd.gz
	cp $(ADD_DIR)/add.bz2 $(BASE_DIR)/floppy/.
	
	cp $(SCRIPTS_DIR)/config $(BASE_DIR)/floppy/.
	cp $(SCRIPTS_DIR)/ethers $(BASE_DIR)/floppy/.
	cp $(SCRIPTS_DIR)/hosts $(BASE_DIR)/floppy/.
	cp $(SCRIPTS_DIR)/firewall.ini $(BASE_DIR)/floppy/.
	cp $(SCRIPTS_DIR)/network.ini $(BASE_DIR)/floppy/.
	cat $(SCRIPTS_DIR)/floppyfw.msg \
		| sed -e 's/FLOPPYFW_VERSION/$FLOPPYFW_VERSION/' \
		> $(BASE_DIR)/floppy/floppyfw.msg
	cp $(SCRIPTS_DIR)/syslinux.cfg $(BASE_DIR)/floppy/.
	cp $(SCRIPTS_DIR)/modules.lst $(BASE_DIR)/floppy/.
	
	cp $(MODULES_BASE_DIR)/basemods.bz2 $(BASE_DIR)/floppy/modules/.
	cp $(MODULES_BASE_DIR)/nics.bz2 $(BASE_DIR)/floppy/modules/.
	cp $(MODULES_BASE_DIR)/tcmods.bz2 $(BASE_DIR)/floppy/modules/.

	cp $(LINUX_KERNEL).upx $(BASE_DIR)/floppy/vmlinuz

floppy: initrd-base add-package floppydir

$(BASE_DIR)/floppy: initrd-base add-package floppydir
# $(BASE_DIR)/floppy

# This will bomb if there are no floppy/ directory but the option would be
# that it wuold basically create a new floppy/ each time which would mean
# I would not be able to edit config and make a new image for testing. 
floppyimage:
	-[ -d /tmp/floppy ] && rm -rf /tmp/floppy
	dd if=/dev/zero of=$(BASE_DIR)/floppyfw.img bs=1024 count=1440
	mkdosfs $(BASE_DIR)/floppyfw.img
	syslinux $(BASE_DIR)/floppyfw.img 
	mkdir /tmp/floppy
	mount -o loop -t vfat $(BASE_DIR)/floppyfw.img /tmp/floppy
	cp -r $(BASE_DIR)/floppy/* /tmp/floppy/.
	umount /tmp/floppy

floppyimage-pppoe: $(MODULES_BASE_DIR)/pppmods.bz2 \
		$(PACKAGES_DIR)/ppp.bz2
	-[ -d /tmp/floppy ] && rm -rf /tmp/floppy
	dd if=/dev/zero of=$(BASE_DIR)/floppyfw.img bs=1024 count=1440
	mkdosfs $(BASE_DIR)/floppyfw.img
	syslinux $(BASE_DIR)/floppyfw.img 
	mkdir /tmp/floppy
	mount -o loop -t vfat $(BASE_DIR)/floppyfw.img /tmp/floppy
	cp -r $(BASE_DIR)/floppy/* /tmp/floppy/.
	cp -r $(PACKAGES_DIR)/ppp.bz2 /tmp/floppy/packages/.
	cp -r $(MODULES_BASE_DIR)/pppmods.bz2 /tmp/floppy/modules/.
	$(SED) "s/^# CONNECT_TYPE=PPPoE/CONNECT_TYPE=PPPoE/" /tmp/floppy/config
	$(SED) "s/^CONNECT_TYPE=DHCP/# CONNECT_TYPE=DHCP/" /tmp/floppy/config
	umount /tmp/floppy

floppy-clean:
	rm -rf $(BASE_DIR)/floppy
